HelpBot Assistant

How can I help you?

The Syncfusion Angular components of Essential JavaScript 1 (jQuery-based widgets) are no longer actively developed, and the 2022 Volume 4 marked the last release. Users are encouraged to switch to the Syncfusion Angular components of the Essential JS 2 library, which has been specifically designed to be lightweight and modular. Its size can be further optimized by including only the necessary controls and features for your application. For more information, please check out the Syncfusion Angular of Essential JS 2 library’s documentation and demo.

Essential JS 1 Angular Overview

Essential JavaScript provides support for Angular Framework through wrappers. Each Syncfusion widgets are created as Angular components with built in support for data binding to make complex property definition easier.

The Syncfusion Angular components are named with prefix ej to avoid conflicting with other library component and offers the following features.

  • Properties
  • Two-way binding
  • Event binding

The Essential JavaScript for Syncfusion Angular components supports Angular release version 6.0.0.

NOTE

To getting started with Syncfusion Angular seed application navigate to here.

Property Binding

Properties of Syncfusion controls can be initialized with the exact casing of original property names. Bind property to the controls within square bracket([]).

For example, create ejAutocomplete component with prefixing of ej- and control name then the properties dataSource and value can be defined as follows.

  • HTML
  • <input type="text" ej-autocomplete [value]= "Austin-Healey" [dataSource]="states" />

    NOTE

    The dataSource states will be defined in component.ts file.

    Event Binding

    Events can be bound to the controls using the event name within bracket [()]. For example, the open event of ejAutocomplete control can be defined as follows.

  • HTML
  • <input type="text" ej-autocomplete (open)="onOpen($event)" />

    Define event definition at component model as like the below code example.

  • JAVASCRIPT
  • export class AppComponent { 
        onOpen(e){
            console.log("Triggers after the suggestion list is opened.");        
        }
    }

    NOTE

    Get event argument values as e.data1,e.data2,e.data3.. (For ex,. for ejAutoComplete get type of event as e.type).

    Two-way Binding

    Two-way binding of Angular synchronizes the value in both view and component model using attribute [(ngModel)]. The same conversion is used for Syncfusion widgets which reflect the changes both ways. In general, we could have more than one property bound to the same variable.

    Two-way binding for ejAutocomplete has been demonstrated in the below code.

  • JAVASCRIPT
  • import { Component } from '@angular/core';
    
    @Component({
        selector: 'my-app',
        template: `<h2>Two-Way Binding</h2>
        <input type="text" ej-autocomplete [dataSource]="states" [(ngModel)]="value"/>
        <input type="text" name="AutoComplete" class="input ej-inputtext" [(ngModel)]="value" />
        `
    })
    export class AppComponent {
        states: Array<string>;
        value:string; 
        constructor() {
            this.states = [
             "Audi S6", "Austin-Healey", "Alfa Romeo", "Aston Martin",
                        "BMW 7 ", "Bentley Mulsanne", "Bugatti Veyron",
                        "Chevrolet Camaro", "Cadillac ",
                        "Duesenberg J ", "Dodge Sprinter",
                        "Elantra", "Excavator",
                        "Ford Boss 302", "Ferrari 360", "Ford Thunderbird ",
                        "GAZ Siber",
                        "Honda S2000", "Hyundai Santro",
                        "Isuzu Swift", "Infiniti Skyline",
                        "Jaguar XJS",
                        "Kia Sedona EX", "Koenigsegg Agera",
                        "Lotus Esprit", "Lamborghini Diablo ",
                        "Mercedes-Benz ", "Mercury Coupe", "Maruti Alto 800",
                        "Nissan Qashqai",
                        "Oldsmobile S98", "Opel Superboss",
                        "Porsche 356 ", "Pontiac Sunbird",
                        "Scion SRS/SC/SD", "Saab Sportcombi", "Subaru Sambar", "Suzuki Swift",
                        "Triumph Spitfire ", "Toyota 2000GT",
                        "Volvo P1800", "Volkswagen Shirako"
            ];
            this.value="Jaguar XJS";
       }
    }

    The below table depicts the properties of all the Syncfusion widgets that supports model binding.

    Control Supported properties
    ejAccordion -
    ejAutoComplete -
    ejBarcode -
    ejBulletGraph featureMeasures-value
    featureMeasures-comparativeMeasureValue
    ejButton -
    ejChart xZoomFactor
    yZoomFactor
    xZoomPosition
    yZoomPosition
    legend.visibility
    ejCheckBox checked
    checkState
    ejCircularGauge value
    minimum
    maximum
    ejColorPicker value
    opacityValue
    ejDatePicker -
    ejDateTimePicker -
    ejDiagram -
    ejDialog -
    ejDigitalGauge value
    ejDropDownList value
    ejGantt dataSource
    selectedRowIndex
    splitterSettings.position
    ejGrid dataSource
    pageSettings.currentPage
    selectedRowIndices
    selectedRowIndex
    ejGroupButton -
    ejFileExplorer -
    ejHeatMap -
    ejHeatMapLegend -
    ejKanban dataSource
    ejLinearGauge value
    minimum
    maximum
    ejListBox value
    ejListView dataSource
    ejMap baseMapIndex
    enablePan
    enableResize
    enableAnimation
    zoomSettings.level
    zoomSettings.minValue
    zoomSettings.maxValue
    zoomSettings.factor
    zoomSettings.enableZoom
    zoomSettings.enableZoomOnSelection
    navigationControl.enableNavigation
    navigationControl.orientation
    navigationControl.absolutePosition
    navigationControl.dockPosition
    ejMaskEdit -
    ejMenu -
    ejNavigationDrawer -
    ejOverview -
    ejPivotGrid -
    ejPivotChart -
    ejPivotSchemaDesigner -
    ejPivotTreeMap -
    ejPivotGauge -
    ejProgressBar -
    ejRadialMenu -
    ejRadialSlider value
    ejRadioButton -
    ejRangeNavigator selectedRangeStart
    selectedRangeEnd
    ejRating value
    ejReportViewer -
    ejRibbon -
    ejRTE value
    ejRotator -
    ejSchedule appointmentSettings.dataSource
    currentView
    currentDate
    ejSignature -
    ejScroller -
    ejSlider value
    ejSparkline -
    ejSpellCheck -
    ejSplitter -
    ejSpreadsheet -
    ejSunburstChart -
    ejSymbolPalette -
    ejTab selectedItemIndex
    ejTagCloud -
    ejTooltip -
    ejTreeGrid dataSource
    selectedRowIndex
    ejNumericTextbox -
    ejPercentageTextbox -
    ejCurrencyTextbox -
    ejTile badge.value
    badge.enabled
    badge.text
    badge.position
    text
    caption.text
    ejTimePicker -
    ejToggleButton -
    ejToolbar -
    ejTreemap dataSource
    weightValuePath
    ejTreeView dataSource
    ejUploadbox -
    ejWaitingPopup -

    NOTE

    For complete understanding of Angular inputs and outputs binding syntaxes, refer this Angular help document.

    Setting complex properties dynamically

    Complex properties don’t have two-way binding support in Angular. To set these complex properties dynamically, use setModel option. For example, editSettings in Grid is a complex property and you can change this dynamically as done in the following code

  • TS
  • import {Component, ViewChild } from '@angular/core';
    import { EJComponents } from 'ej-angular2';
    
    @Component({
        selector: 'my-app',
        template: `<button (click)="set()">Click</button>
         <ej-grid #grid  [allowPaging]="true" [allowScrolling]="true" [toolbarSettings]="toolbarItems" [dataSource]="gridData">
           <e-columns>
            <e-column field="OrderID" headerText="Order ID"  width="85" textAlign="right"></e-column>
            <e-column field="CustomerID" headerText="Customer ID" textAlign="left"  width="100"></e-column>
            <e-column field="EmployeeID" headerText="Employee ID " width="120" textAlign="left"></e-column> 
            <e-column field="Freight" headerText="Freight" width="120" textAlign="left"></e-column> 
            <e-column field="ShipCity" headerText="Ship City " width="120" textAlign="left"></e-column>   
          </e-columns>
        </ej-grid>`
    })
    export class AppComponent {
         @ViewChild('grid') grid: EJComponents<any, any>; 
            public gridData; 
            public toolbarItems; 
            public Edit; 
           
            constructor() 
            { 
               this.gridData = window.gridData; 
               this.toolbarItems = { showToolbar : true, toolbarItems : ["add", "edit", "delete", "update", "cancel"]}; 
               this.Edit = true; 
            } 
          
           set(e: any){  
               if(this.Edit) 
                  //update the editSettings based on value in button click event 
                  this.grid.widget.option({editSettings: {allowEditing:true,allowAdding: true,allowDeleting: true,showAddNewRow:true,rowPosition: ej.Grid.RowPosition.Bottom }}) 
            else 
                 this.grid.widget.option({editSettings: {allowEditing:false,allowAdding: false,allowDeleting: false,showAddNewRow:false,rowPosition: ej.Grid.RowPosition.Bottom }}) 
          } 
    }

    Invoking EJ widget methods from component instance

    You can invoke the ej widget’s public methods using Angular component instance reference like the below syntax.

  • JAVASCRIPT
  • <componentInstance>.widget.<methodName>(<params_if_any>)

    For example, to invoke clearText method of ejAutocomplete widget, you can use like myApp.widget.clearText(). So the complete code structure of app.component.ts will be as follows.

  • JAVASCRIPT
  • import {Component} from '@angular/core';
    
    @Component({
        selector: 'my-app',
        template: ` <h2>Two-Way Binding</h2>
        <button id="clearTxt" (click)="myApp.widget.clearText()">clearText</button>
        <input #myApp type="text" ej-autocomplete [dataSource]="states" (open)="onOpen($event)" [(ngModel)]="value"/>
        <input type="text" name="AutoComplete" class="input ej-inputtext" [(ngModel)]="value" />
        `
    })
    export class AppComponent {
        states: Array<string>;
        value:string; 
        constructor() {
            this.states = [
             "Audi S6", "Austin-Healey", "Alfa Romeo", "Aston Martin",
                        "BMW 7 ", "Bentley Mulsanne", "Bugatti Veyron",
                        "Chevrolet Camaro", "Cadillac ",
                        "Duesenberg J ", "Dodge Sprinter",
                        "Elantra", "Excavator",
                        "Ford Boss 302", "Ferrari 360", "Ford Thunderbird ",
                        "GAZ Siber",
                        "Honda S2000", "Hyundai Santro",
                        "Isuzu Swift", "Infiniti Skyline",
                        "Jaguar XJS",
                        "Kia Sedona EX", "Koenigsegg Agera",
                        "Lotus Esprit", "Lamborghini Diablo ",
                        "Mercedes-Benz ", "Mercury Coupe", "Maruti Alto 800",
                        "Nissan Qashqai",
                        "Oldsmobile S98", "Opel Superboss",
                        "Porsche 356 ", "Pontiac Sunbird",
                        "Scion SRS/SC/SD", "Saab Sportcombi", "Subaru Sambar", "Suzuki Swift",
                        "Triumph Spitfire ", "Toyota 2000GT",
                        "Volvo P1800", "Volkswagen Shirako"
            ];
            this.value="Jaguar XJS";
       }
       onOpen(e){
            console.log("Triggers after the suggestion list is opened.");        
        }
    }

    NOTE

    Here, We don’t need to import the specific component file. Because all component files are import in EJAngular2Module from ej-angular2 package in app.module.ts file

    • We can invoke the clearText method of ejAutocomplete widget using ViewChild in model file. Refer the below code snippet
  • TS
  • import {Component, ViewChild } from '@angular/core';
    import { EJComponents } from 'ej-angular2';
    
    @Component({
        selector: 'my-app',
        template: ` <h2>Two-Way Binding</h2>
        <button id="clearTxt" #autocomplete (click)="buttonclick($event)">clearText</button>
        <input #myApp type="text" ej-autocomplete [dataSource]="states" (open)="onOpen($event)" [(ngModel)]="value"/>
        <input type="text" name="AutoComplete" class="input ej-inputtext" [(ngModel)]="value" />
        `
    })
    export class AppComponent {
        states: Array<string>;
        value:string; 
        @ViewChild('myApp') autocomplete: EJComponents<any, any>;
        constructor() {
            this.states = [
             "Audi S6", "Austin-Healey", "Alfa Romeo", "Aston Martin",
                        "BMW 7 ", "Bentley Mulsanne", "Bugatti Veyron",
                        "Chevrolet Camaro", "Cadillac ",
                        "Duesenberg J ", "Dodge Sprinter",
                        "Elantra", "Excavator",
                        "Ford Boss 302", "Ferrari 360", "Ford Thunderbird ",
                        "GAZ Siber",
                        "Honda S2000", "Hyundai Santro",
                        "Isuzu Swift", "Infiniti Skyline",
                        "Jaguar XJS",
                        "Kia Sedona EX", "Koenigsegg Agera",
                        "Lotus Esprit", "Lamborghini Diablo ",
                        "Mercedes-Benz ", "Mercury Coupe", "Maruti Alto 800",
                        "Nissan Qashqai",
                        "Oldsmobile S98", "Opel Superboss",
                        "Porsche 356 ", "Pontiac Sunbird",
                        "Scion SRS/SC/SD", "Saab Sportcombi", "Subaru Sambar", "Suzuki Swift",
                        "Triumph Spitfire ", "Toyota 2000GT",
                        "Volvo P1800", "Volkswagen Shirako"
            ];
            this.value="Jaguar XJS";
       }
       buttonclick(e){
           this.autocomplete.widget.clearText();
       }
       onOpen(e){
            console.log("Triggers after the suggestion list is opened.");        
        }
    }

HelpBot Assistant

How can I help you?

The Syncfusion React components of Essential JavaScript 1 (jQuery-based widgets) are no longer actively developed, and the 2022 Volume 4 marked the last release. Users are encouraged to switch to the Syncfusion React components of the Essential JS 2 library, which has been specifically designed to be lightweight and modular. Its size can be further optimized by including only the necessary controls and features for your application. For more information, please check out the Syncfusion React of Essential JS 2 library’s documentation and demo.

Welcome to Syncfusion Essential React JS

React is an DOM management library that is used to create user interfaces, it computes the minimal set of changes that makes keep your DOM up-to-date.
Essential JavaScript components are supported to React JavaScript library through wrappers in ej.web.react.min.js file.

Getting started with React

This section briefly explains about how to create a web application with Syncfusion React components.

Create React Application layout

Include the following dependencies for render React components with Syncfusion widgets.

  • HTML
  • <!DOCTYPE html>
    <html>
    <head>
        <meta charset="UTF-8" />
        <title>React JS Getting started</title>
        <link href="http://cdn.syncfusion.com/14.3.0.49/js/web/flat-azure/ej.web.all.min.css" rel="stylesheet" />
        <script src="http://cdn.syncfusion.com/js/assets/external/react.min.js"></script>
        <script src="http://cdn.syncfusion.com/js/assets/external/react-dom.min.js"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/babel-core/5.8.34/browser.min.js"></script>
        <script src="http://cdn.syncfusion.com/js/assets/external/jquery-3.0.0.min.js"></script>
        <script src="http://js.syncfusion.com/demos/web/scripts/jsondata.min.js"></script>
        <script src="http://cdn.syncfusion.com/js/assets/external/jsrender.min.js"></script>
        <script src="http://cdn.syncfusion.com/14.3.0.49/js/web/ej.web.all.min.js"></script>
        <script src="http://cdn.syncfusion.com/14.3.0.49/js/common/ej.web.react.min.js"></script>
    </head>
    <body>
       <!--Add React JS components-->
    </body>
    </html>

    IMPORTANT

    From React v16.x.x, support for React.createClass has been removed. So if you are using react framework later versions then, you need to refer create-react-class package separately.

    Add React Components

    React components are typically written in JSX. It is allowing quoting of HTML and using HTML tag’s syntax to render sub-components. HTML syntax is processed into JavaScript calls of the React library.

    To translate JSX to plain JavaScript, we must use <script type=”text/babel”> and refer the browser.min.js file to perform the transformation in the browser.

    To render the React components, you must have defined the HTML div element with id attribute in HTML file which is target element of React components.

    Create a HTML file and paste the following content

  • HTML
  • <div id="container"></div>
    <script type="text/babel" src="app.jsx">
    </script>

    Create a JSX file and paste the following content

  • JS
  • ReactDOM.render(   
    		  <EJ.Grid dataSource = {window.gridData} pageSettings-currentPage={2} allowGrouping = {true} 
    allowPaging = {true} allowSorting= {true}>
                        <columns>
    <column field="OrderID" headerText="Order ID" textAlign="right" width={90} />
    <column field="EmployeeID" headerText="Employee ID" textAlign="right" width={90} />
                            <column field="Freight" headertext="Freight" width={90} />
    </columns>
    </EJ.Grid>,
    document.getElementById('container')
    );

    Output of above code

    gettingstarted

    Content template

    It provides to render the multiple components inside of single components. For example if you are using the EJ.Grid component inside the EJ.Dialog, it can be rendered as like mentioned in the below code example

  • HTML
  • <div id="container"></div>
    
        <script type="text/babel">
    		ReactDOM.render(  
    		<EJ.Dialog title="dialog"> 
    		  <EJ.Grid dataSource = {window.gridData} pageSettings-currentPage={2} allowGrouping = {true} 
    allowPaging = {true} allowSorting= {true}>
                        <columns>
    <column field="OrderID" headerText="Order ID" textAlign="right" width={90} />
    <column field="EmployeeID" headerText="Employee ID" textAlign="right" width={90} />
                            <column field="Freight" headertext="Freight" width={90} />
    </columns>
    </EJ.Grid>
    </EJ.Dialog>,
    document.getElementById('container')
    );
        </script>

    Output of above code

    contenttemplate

    React application with NPM packages

    We can create the React application with NPM packages.

    Setup

    Pre-requisites

    We will need Node.js if you don’t have it installed on your machine, check the link from the table below.

    SN Software Description
    1 Node.js and NPM Node.js is the platform needed for the Cordova development. Checkout <a href=https://nodejs.org/en/download/package-manager/> Node.js package-manager </a>

    Gulp is a command line task runner using Node.js platform. It runs custom defined repetitious tasks.

    To use Gulp, you need to install it as a global module through NPM.

    • npm install –global gulp

    Configuration

    This section briefly explains about how to configure the package.json and gulpfile.js file.

    package.json

    Create a package.json file which is best way to manage locally installed packages.

    NOTE

    If we used the gulp-react plugin, we don’t need to include the browser.js file on the page either.

  • JS
  • {
      "name": "ejreact",
      "version": "1.0.0",
       "devDependencies": {
        "browser-sync": "^2.14.3",
        "gulp": "^3.9.1",
        "gulp-clean": "^0.3.2",
        "gulp-react": "^3.1.0",
        "gulp-watch": "^4.3.9"
      }
    }
    gulpfile.js

    This file will give you a taste of what gulp does.

  • JS
  • var gulp = require('gulp');
    var browserSync = require('browser-sync').create();
    var react = require('gulp-react');
    var watch = require('gulp-watch');
    var clean = require('gulp-clean');
    var reload = browserSync.reload;
    
    gulp.task('build',['clean'], function () {
        //Convert jsx to js 
        gulp.src('source/samples/**/*.jsx')
            .pipe(react())
            .pipe(gulp.dest('source/jsx'));
    
    });
    
    gulp.task('clean', function () {
       return gulp.src('app', {read: false})
            .pipe(clean());
    });
    
    // Static Server + watching html files
    gulp.task('serve', function () {
        browserSync.init({
            server: {
                baseDir: "./"
            }
        });
    });
    
    // Files watching
    gulp.task('watch', ['build', 'serve'], function () {
        gulp.watch(["source/samples/**/*.{js,jsx,html}"], ['build', reload]);
    })
    
    gulp.task('default', ['watch']);

    Converting JSX to JavaScript with React

    When building with React, you can write plain JavaScript or in JSX. JSX is a preprocessor that gives you a more concise syntax.

    which is easier and more readable, but it’s needs to be converted to plain JavaScript through gulp-react plugin.

  • JS
  • ReactDOM.render(   
    		  <EJ.Grid dataSource = {window.gridData} pageSettings-currentPage={2} allowGrouping = {true} 
    allowPaging = {true} allowSorting= {true}>
                        <columns>
    <column field="OrderID" headerText="Order ID" textAlign="right" width={90} />
    <column field="EmployeeID" headerText="Employee ID" textAlign="right" width={90} />
                            <column field="Freight" headertext="Freight" width={90} />
    </columns>
    </EJ.Grid>,
    document.getElementById('container')
    );

    With the help of gulp-react and its gulp plugin, you can convert JSX to JavaScript by piping react() into the build task

  • JS
  • gulp.task('build',['clean'], function () {
        //Convert jsx to js 
        gulp.src('source/samples/**/*.jsx')
            .pipe(react())
            .pipe(gulp.dest('source/jsx'));
    
    });

    Watching JS, JSX and HTML files for changes

    Let’s configure gulp’s watch task to watch for JS, JSX and HTML files, then execute build and serve tasks.

  • JS
  • // Files watching
    gulp.task('watch', ['build', 'serve'], function () {
        gulp.watch(["source/samples/**/*.{js,jsx,html}"], ['build', reload]);
    })

    Removing files and folders

    Let’s configure gulp’s clean task to removing files and folders.

  • JS
  • gulp.task('clean', function () {
       return gulp.src('app', {read: false})
            .pipe(clean());
    });

    Run Application

    Create an index.html file, then include the following dependencies to render the React application with Essential JS widgets. This index.html will be act as a start page of the application.

  • HTML
  • <!DOCTYPE html>
    <html>
    <head>
        <meta charset="UTF-8" />
        <title>React JS Getting started</title>
        <link href="http://cdn.syncfusion.com/14.3.0.52/js/web/flat-azure/ej.web.all.min.css" rel="stylesheet" />
        <script src="http://cdn.syncfusion.com/js/assets/external/react.min.js"></script>
        <script src="http://cdn.syncfusion.com/js/assets/external/react-dom.min.js"></script>
        <script src="http://cdn.syncfusion.com/js/assets/external/jquery-3.0.0.min.js"></script>
        <script src="http://js.syncfusion.com/demos/web/scripts/jsondata.min.js"></script>
        <script src="http://cdn.syncfusion.com/js/assets/external/jsrender.min.js"></script>
        <script src="http://cdn.syncfusion.com/14.3.0.52/js/web/ej.web.all.min.js"></script>
        <script src="http://cdn.syncfusion.com/14.3.0.52/js/common/ej.web.react.min.js"></script>
    </head>
    
    <body>
        <div id="container"></div>
        <script src="source/samples/grid/grid.js">
        </script>
    </body>
    </html>

    Create a JSX file and paste the following content.

  • JS
  • ReactDOM.render(   
    		  <EJ.Grid dataSource = {window.gridData} pageSettings-currentPage={2} allowGrouping = {true} 
    allowPaging = {true} allowSorting= {true}>
                        <columns>
    <column field="OrderID" headerText="Order ID" textAlign="right" width={90} />
    <column field="EmployeeID" headerText="Employee ID" textAlign="right" width={90} />
                            <column field="Freight" headertext="Freight" width={90} />
    </columns>
    </EJ.Grid>,
    document.getElementById('container')
    );

    Now type the below commands step by step for launching ReactJS application in browser.

    • npm install – To install the npm packages

    • gulp – To launch application in browser

    runapplication1

    Screenshot of launching application

    runapplication2